//
//  KaiUI.h
//  KaiUI
//
//  Created by Maksim Rogov on Tue Feb 01 2005.
//  Copyright (c) 2005 Nullriver Software. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <EDCommon/EDStream.h>
#import <EDCommon/EDUDPSocket.h>
#import <EDCommon/NSFileHandle+Extensions.h>

@interface KaiUI : NSObject {
	EDStream		*   engineStream;
	id					delegate;
}

/* Public */
- (void)discoverAndNotify:(id)theDelegate;
- (void)connectToEngineOnHost:(NSString *)theHost port:(int)thePort delegate:(id)theDelegate;
- (void)attach;
- (void)takeOver;
- (void)getState;
- (void)sendCapabilties:(NSString *)clientCapabilities;
- (void)loginWithUserName:(NSString *)userName userPassword:(NSString *)userPassword;
- (void)goToVector:(NSString *)theVector withPassword:(NSString *)vectorPassword;
- (void)getSubVectorsForVector:(NSString *)theVector;
- (void)chatMode:(NSString *)theVector;
- (void)chat:(NSString *)theText;
- (void)createVectorWithDescription:(NSString *)vectorDescription maxUsers:(int)maxUsers password:(NSString *)vectorPassword;
- (void)setStatus:(int)theStatus players:(int)playerCount;
- (void)inviteUser:(NSString *)userName intoVector:(NSString *)theVector;
- (void)kickUser:(NSString *)userName;
- (void)banUser:(NSString *)userName;
- (void)sendPrivateMessage:(NSString *)theMessage toUser:(NSString *)userName;
- (void)specificCountForVector:(NSString *)theVector;
- (void)getMetrics;
- (void)getProfileForUser:(NSString *)userName;
- (void)getAvatarForUser:(NSString *)userName;
- (void)addContact:(NSString *)userName;
- (void)removeContact:(NSString *)userName;
- (void)detach;

/* Private */
- (NSString *)escape:(NSString *)theString;
- (NSString *)unescape:(NSString *)theString;
- (void)sendToEngine:(NSString *)theMessage;
- (void)receiveFromEngine:(NSNotification *)aNotification;

@end
